<?php

namespace Drupal\cmlapi\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\file\Entity\File;

/**
 * GetLast.
 */
class CurrentXmlPath extends ControllerBase {

  /**
   * LastFilePath.
   */
  public static function get($xmlkey = 'import') {
    $filepath = FALSE;
    $cml = GetCml::actual();
    if ($cml) {
      $cml_id = $cml->id();
      $filepath = &drupal_static("CurrentXmlPath::get():$xmlkey:$cml_id");
      if (!isset($filepath)) {
        $cache_key = "CurrentXmlPath-$xmlkey:$cml_id";
        if ($cache = \Drupal::cache()->get($cache_key)) {
          $filepath = $cache->data;
        }
        else {
          if (is_object($cml)) {
            $cml_xml = $cml->field_file->getValue();
            $files = [];
            $data = FALSE;
            $filekeys[$xmlkey] = TRUE;
            if (!empty($cml_xml)) {
              foreach ($cml_xml as $xml) {
                $file = File::load($xml['target_id']);
                $filename = $file->getFilename();
                $filekey = strstr($filename, '.', TRUE);
                if (isset($filekeys[$filekey]) && $filekeys[$filekey]) {
                  $files[] = $file->getFileUri();
                }
              }
            }
            $filepath = array_shift($files);
            \Drupal::cache()->set($cache_key, $filepath);
          }
        }
      }
    }
    return $filepath;
  }

}
