<?php

namespace Drupal\cmlapi\Controller;

use Drupal\Core\Controller\ControllerBase;

/**
 * GetLast.
 */
class GetCml extends ControllerBase {

  /**
   * List.
   */
  public static function actual() {
    // Has 'progress' status.
    if ($curent = self::curent()) {
      return $curent;
    }
    // Has 'new' status, oldest.
    if ($next = self::next()) {
      return $next;
    }
    // [failure|success] latest.
    if ($last = self::last()) {
      return $last;
    }
    return FALSE;
  }

  /**
   * List.
   */
  public static function list() {
    $list = self::query();
    return $list;
  }

  /**
   * List.
   */
  public static function next() {
    $next = FALSE;
    $count = 1;
    $status = ['new'];
    if (!empty($list = self::query($count, $status))) {
      $next = array_shift($list);
    }
    return $next;
  }

  /**
   * Last.
   */
  public static function last() {
    $last = FALSE;
    $count = 1;
    $status = ['failure', 'success'];
    if (!empty($list = self::query($count, $status, 'DESC'))) {
      $last = array_shift($list);
    }
    return $last;
  }

  /**
   * List.
   */
  public static function curent() {
    $current = FALSE;
    $count = 1;
    $status = ['progress'];
    if (!empty($list = self::query($count, $status))) {
      $current = array_shift($list);
    }
    return $current;
  }

  /**
   * Query.
   */
  public static function query($count = FALSE, $status = ['new', 'progress'], $sort = 'ASC') {
    $entities = [];
    $entity_type = 'cml';
    $storage = \Drupal::entityManager()->getStorage($entity_type);
    $query = \Drupal::entityQuery($entity_type)
      ->condition('status', 1)
      ->sort('created', $sort)
      ->condition('type', 'catalog')
      ->condition('field_status', $status, 'IN')
      ->condition('field_file', 'NULL', '!=');
    if ($count) {
      $query->range(0, $count);
    }
    $ids = $query->execute();
    if (!empty($ids)) {
      foreach ($storage->loadMultiple($ids) as $id => $entity) {
        $entities[$id] = $entity;
      }
    }
    return $entities;
  }

}
