<?php

namespace Drupal\cmlapi\Hook;

use Drupal\Core\Controller\ControllerBase;
use Drupal\cmlapi\Controller\GetLastCml;

/**
 * Hook Cron.
 */
class Cron extends ControllerBase {

  /**
   * Hook.
   */
  public static function hook() {
    $start = time();
    $lastRun = \Drupal::state()->get('cmlapi.cron_last_run');
    if (!isset($lastRun)) {
      $lastRun = strtotime('now - 1 month');
    }
    $runToday = format_date($start, 'custom', 'Ymd') == format_date($lastRun, 'custom', 'Ymd');
    if (!$runToday) {
      $operations = [];
      $searchCatalog = GetLastCml::findOldCatalog();
      $emptyCml = GetLastCml::findEmptyCml();
      $operations = array_merge($operations, $searchCatalog, $emptyCml);
      $batch = [
        'title' => t('Delete cml'),
        'operations' => $operations,
        'finished' => 'Drupal\cmlapi\Hook\Cron::oldCmlCallback',
        'file' => drupal_get_path('module', 'cmlapi') . '/cmlapi.module',
      ];

      batch_set($batch);
      $batch = & batch_get();
      $batch['progressive'] = FALSE;
      batch_process();
    }
  }

  /**
   * Задача для очереди.
   */
  public static function deleteOldCml($cmlId) {
    $cml = \Drupal::entityManager()->getStorage('cml')->load($cmlId);
    if (isset($cml)) {
      $created = strtotime($cml->field_cml_date->value);
      $config = \Drupal::config('cmlapi.settings');
      $month = FALSE;
      if (!empty($config->get('live-long'))) {
        $month = strtotime($config->get('live-long'));
      }
      if (!$month) {
        $month = strtotime('now - 1 month');
      }
      if ($created < $month) {
        $cml->delete();
      }
    }
  }

  /**
   * Done.
   */
  public static function oldCmlCallback() {
    \Drupal::state()->set('cmlapi.cron_last_run', time());
  }

}
